# Summary

[README](README.md)

# Running the code

- [Runner - Divide Code Into Years and Days](Runner.md)
- [Main - Select a Day and Year to Run](Main.md)

# Utility Mini-Library

- [Util - Extend Standard Types](Util.md)
  - [Util.Eff - Effects and Effect Accessories](Util/Eff.md)
  - [Util.Digits - Pattern Matching Integers as Lists of Digits](Util/Eff.md)
- [Array - Arrays With Constant Time Indexing and Slicing](Array.md)
- [Parser - Recursive Descent Parsing, With Effects](Parser.md)
  - [Interface - Core Parsing Functionality](Parser/Interface.md)
  - [ParserState - Custom Effect for Parser Internal State](Parser/ParserState.md)
  - [Numbers - Parsers for Numerical Values](Parser/Numbers.md)
  - [JSON - A JSON Parser](Parser/JSON.md)

# Problems

- [2015](Years/Y2015.md)
  - [Day 1 - Warmup](Years/Y2015/Day1.md)
  - [Day 2 - Early Effectful Parsing](Years/Y2015/Day2.md)
  - [Day 3 - Mutually Recursive Functions](Years/Y2015/Day3.md)
  - [Day 4 - Basic FFI](Years/Y2015/Day4.md)
  - [Day 5 - Views and Dependent Pattern Matching](Years/Y2015/Day5.md)
  - [Day 6 - Naive 2D Grid](Years/Y2015/Day6.md)
  - [Day 7 - Dependent Maps and Indexed Type Familes](Years/Y2015/Day7.md)
  - [Day 8 - Proper Effectful Parsers](Years/Y2015/Day8.md)
  - [Day 9 - Naive Graph Traversal](Years/Y2015/Day9.md)
  - [Day 10 - Digits View](Years/Y2015/Day10.md)
  - [Day 11 - Refinement Types](Years/Y2015/Day11.md)
  - [Day 12 - Custom Parser Effect and DLists](Years/Y2015/Day12.md)
